searchData={"content_type":"text/markdown","items":[{"doc":"Provides an interface which dispatches the function to the right adapter.","ref":"AnyHttp.html","title":"AnyHttp","type":"module"},{"doc":"Defines in your application the following configuration depending of the adapter you choose:\n\n    config :any_http, :client_adapter, AnyHttp.Adapters.Req","ref":"AnyHttp.html#module-configuration","title":"Configuration - AnyHttp","type":"module"},{"doc":"Makes a DELETE request to the given URL.","ref":"AnyHttp.html#delete/4","title":"AnyHttp.delete/4","type":"function"},{"doc":"","ref":"AnyHttp.html#from_rfc1123_date!/1","title":"AnyHttp.from_rfc1123_date!/1","type":"function"},{"doc":"Makes a GET request to the given URL.","ref":"AnyHttp.html#get/4","title":"AnyHttp.get/4","type":"function"},{"doc":"Makes a HEAD request to the given URL.","ref":"AnyHttp.html#head/3","title":"AnyHttp.head/3","type":"function"},{"doc":"Makes a PATCH request to the given URL.","ref":"AnyHttp.html#patch/4","title":"AnyHttp.patch/4","type":"function"},{"doc":"Makes a POST request to the given URL.","ref":"AnyHttp.html#post/4","title":"AnyHttp.post/4","type":"function"},{"doc":"Makes a PUT request to the given URL.","ref":"AnyHttp.html#put/4","title":"AnyHttp.put/4","type":"function"},{"doc":"","ref":"AnyHttp.html#request/5","title":"AnyHttp.request/5","type":"function"},{"doc":"","ref":"AnyHttp.html#to_rfc1123_date/2","title":"AnyHttp.to_rfc1123_date/2","type":"function"},{"doc":"","ref":"AnyHttp.html#t:adapter_opts/0","title":"AnyHttp.adapter_opts/0","type":"type"},{"doc":"","ref":"AnyHttp.html#t:body/0","title":"AnyHttp.body/0","type":"type"},{"doc":"","ref":"AnyHttp.html#t:headers/0","title":"AnyHttp.headers/0","type":"type"},{"doc":"","ref":"AnyHttp.html#t:method/0","title":"AnyHttp.method/0","type":"type"},{"doc":"","ref":"AnyHttp.html#t:response/0","title":"AnyHttp.response/0","type":"type"},{"doc":"","ref":"AnyHttp.html#t:url/0","title":"AnyHttp.url/0","type":"type"},{"doc":"Defines the behaviour for the HTTP adapters to implement.","ref":"AnyHttp.Client.html","title":"AnyHttp.Client","type":"behaviour"},{"doc":"","ref":"AnyHttp.Client.html#c:request/5","title":"AnyHttp.Client.request/5","type":"callback"},{"doc":"Defines a generic struct to encapsulate a HTTP response.","ref":"AnyHttp.Response.html","title":"AnyHttp.Response","type":"module"},{"doc":"","ref":"AnyHttp.Response.html#t:body/0","title":"AnyHttp.Response.body/0","type":"type"},{"doc":"","ref":"AnyHttp.Response.html#t:headers/0","title":"AnyHttp.Response.headers/0","type":"type"},{"doc":"","ref":"AnyHttp.Response.html#t:status/0","title":"AnyHttp.Response.status/0","type":"type"},{"doc":"","ref":"AnyHttp.Response.html#t:t/0","title":"AnyHttp.Response.t/0","type":"type"},{"doc":"Defines the adapter for the `:httpc` Erlang module.","ref":"AnyHttp.Adapters.Httpc.html","title":"AnyHttp.Adapters.Httpc","type":"module"},{"doc":"","ref":"AnyHttp.Adapters.Httpc.html#t:body/0","title":"AnyHttp.Adapters.Httpc.body/0","type":"type"},{"doc":"","ref":"AnyHttp.Adapters.Httpc.html#t:content_type/0","title":"AnyHttp.Adapters.Httpc.content_type/0","type":"type"},{"doc":"","ref":"AnyHttp.Adapters.Httpc.html#t:header/0","title":"AnyHttp.Adapters.Httpc.header/0","type":"type"},{"doc":"","ref":"AnyHttp.Adapters.Httpc.html#t:headers/0","title":"AnyHttp.Adapters.Httpc.headers/0","type":"type"},{"doc":"","ref":"AnyHttp.Adapters.Httpc.html#t:http_version/0","title":"AnyHttp.Adapters.Httpc.http_version/0","type":"type"},{"doc":"","ref":"AnyHttp.Adapters.Httpc.html#t:httpc_error/0","title":"AnyHttp.Adapters.Httpc.httpc_error/0","type":"type"},{"doc":"","ref":"AnyHttp.Adapters.Httpc.html#t:httpc_response/0","title":"AnyHttp.Adapters.Httpc.httpc_response/0","type":"type"},{"doc":"","ref":"AnyHttp.Adapters.Httpc.html#t:status_code/0","title":"AnyHttp.Adapters.Httpc.status_code/0","type":"type"},{"doc":"","ref":"AnyHttp.Adapters.Httpc.html#t:status_line/0","title":"AnyHttp.Adapters.Httpc.status_line/0","type":"type"},{"doc":"","ref":"AnyHttp.Adapters.Httpc.html#t:url/0","title":"AnyHttp.Adapters.Httpc.url/0","type":"type"},{"doc":"Defines the adapter for the `req` library.","ref":"AnyHttp.Adapters.Req.html","title":"AnyHttp.Adapters.Req","type":"module"},{"doc":"","ref":"AnyHttp.Adapters.Req.html#t:request/0","title":"AnyHttp.Adapters.Req.request/0","type":"type"},{"doc":"","ref":"AnyHttp.Error.html","title":"AnyHttp.Error","type":"exception"},{"doc":"","ref":"AnyHttp.Error.html#t:t/0","title":"AnyHttp.Error.t/0","type":"type"},{"doc":"","ref":"AnyHttp.Error.html#t:type/0","title":"AnyHttp.Error.type/0","type":"type"},{"doc":"# Any HTTP\n\nElixir library which wraps the main HTTP libraries. It allows the final project to decide which\nHTTP library they want to use and provide an unified interface.\n\n[Documentation](https://hexdocs.pm/any_http)","ref":"readme.html","title":"Any HTTP","type":"extras"},{"doc":"```elixir\ndef deps do\n  [\n    {:any_http, \"~> 0.3\"}\n  ]\nend\n```","ref":"readme.html#installation","title":"Installation - Any HTTP","type":"extras"},{"doc":"### [Req](https://github.com/wojtekmach/req)\n\nDeclare your favorite HTTP library in the configuration\n\n```elixir\nconfig :any_http, client_adapter: AnyHttp.Adapters.Req\n```\n\nEnsure, you added the corresponding dependency for the adapter:\n\n```elixir\ndef deps do\n  [\n    {:req, \"~> 0.4\"}\n  ]\nend\n```\n\n### [:httpc](https://www.erlang.org/doc/man/httpc.html)\n\nDeclare your favorite HTTP library in the configuration\n\n```elixir\nconfig :any_http, client_adapter: AnyHttp.Adapters.Httpc\n```","ref":"readme.html#configuration","title":"Configuration - Any HTTP","type":"extras"},{"doc":"Just call the `AnyHttp` module to interact with HTTP:\n\n```elixir\nAnyHttp.post(\n  # Provide the URL as a string or an URI\n  \"https://my_server/api\",\n  # Provide the HTTP headers as map or list of tuple, put nil if none\n  %{\"content-type\" => \"application/json\"},\n  # Provide the body, put nil if none\n  Jason.encode!(%{hello: \"world\"}),\n  # Provide the adapter options, can be ommited\n  receive_timeout: :timer.seconds(5)\n)\n```\n\nThe result will look like:\n\n```elixir\n{:ok,\n  %AnyHttp.Response{\n    status: 201,\n    headers: %{\"content-type\" => [\"application/json\"]},\n    body: \"{\\\"bye\\\":\\\"world\\\"}\"\n  }\n}\n```","ref":"readme.html#usage","title":"Usage - Any HTTP","type":"extras"}]}